<?PHP if (!defined('PmWiki')) exit();

/*

  Amp Detect - Checks the User Agent string to detect if we are
    being crawled by amp reverse proxies

 *****
 *
 *  Copyright 2018 Carlos A. Bonamigo <cabsec.pmwiki@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****

*/

$RecipeInfo['AmpDetect']['Version'] = '20181118';

SDV($EnableAmpDetect , '1');

SDVA($AmpDetectUA, array(
  # AMP proxy crawler - first crawl (sometimes it shows up again) - tested in many vpns in different countries
  'Mozilla/5.0 (Linux; Android 6.0.1; Nexus 5X Build/MMB29P) AppleWebKit/537.36 (KHTML, like Gecko) '.
    'Chrome/41.0.2272.96 Mobile Safari/537.36 (compatible; Google-AMPHTML)',
  # AMP crawler - second crawl forward - - tested in many vpns in different countries
  'Mozilla/5.0 (Linux; Android 6.0.1; Nexus 5X Build/MMB29P) AppleWebKit/537.36 (KHTML, like Gecko) '.
    'Chrome/41.0.2272.96 Mobile Safari/537.36 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)',
  # AMP validator - when you need to validate your amp pages
  'Mozilla/5.0 (Linux; Android 6.0.1; Nexus 5X Build/MTC19V) AppleWebKit/537.36 (KHTML, like Gecko) '.
    'Chrome/51.0.2704.81 Mobile Safari/537.36 (compatible; validator.ampproject.org) AppEngine-Google; '.
    '(+http://code.google.com/appengine; appid: s~amp-validator)'
));

function AmpDetect($gua=''){
global $EnableAmpDetect ,
  $AmpDetectUA;

if(!$EnableAmpDetect)
  return false;

$dua = $AmpDetectUA; # amp proxy UA
if($gua != '') $ua = $gua;
$ia = false; #isamp

foreach($dua as $sua)
  if($ua == $sua) $ia = true;

return $ia;
}

$IsAmp = AmpDetect();

?>